{
  **************************************************************************************************
  *     Coded By Brian Carpenter to demonstrate the Amploc 25 amp Hall Sensor                      *
  *                                                                                                *
  *     Nothing Magical about this other than i coded it and that in itself is amazing             *
  *                                                                                                *
  *     The Code uses a MCP3202 ADC,  the data sheet for the Amploc 25amp states that the operating*
  *     voltage is 5v to, I think, 10v.  It works great at 3.3v                                    *
  *                                                                                                *
  **************************************************************************************************
}


CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000


  DIO         = 7              '' Propeller IO pin connected to combined DI and DO pins of MCP3202
  CLK         = 8              '' Propeller IO pin connected to clock pin of MCP3202
  CS          = 9              '' Propeller iO pin connected to chip select pin of MCP3202
  RX_PIN      = 31             '' Used for comunication to Hyperterminal
  TX_PIN      = 30
  BAUD_RATE   = 9600

  
  N = 4095                   
  lowStart = 4000
  highStart = 0

{{
NOTES **************************************************************************************************
1) Connect MCP3202 per MicroChip spec sheet. DI and DO lines should be connected together without resistor.
2) Adjust the IO lines in above CON section to suit your arrangement


}}
  
OBJ

  ADC   :       "MCP3202"
  ser   :       "FullDuplexSerial"
VAR

  long  ch0
  long  ch1
  long  lowNum
  long  HighNum
  long  Amps
  long  AmpsFirst
  long  AmpsLast
PUB  MAIN      

  ADC.start(DIO, CLK, CS, 0)                            '' See MCP3202.spin for what these entries mean
  ser.start(RX_PIN, TX_PIN, 0, BAUD_RATE)

  REPEAT 
    lowNum := lowStart
    HighNum := highStart
      REPEAT N
        ch1 := adc.in(1)
        if ch1 > highNum
          highNum := ch1
        elseif lowNum > ch1
          lowNum := ch1
    Amps := (highNum - lowNum)/ 2
    Amps /= 4  
    AmpsFirst := Amps / 10
    AmpsLast := Amps // 10

    waitcnt(clkfreq + cnt)  
    ser.str(string("Low Count  "))    
    ser.dec(lowNum)              'display decimal value 
    ser.str(string(", High Count  "))     
    ser.dec(highNum)             'display decimal value
    ser.str(string(", Amps  "))
    ser.dec(AmpsFirst)           'display the 10's portion of the amps value
    ser.str(string("."))
    ser.dec(AmpsLast)            'display the decimal value of the amps value
    ser.str(string($0D, $0A))
    